ln -sf /usr/share/zoneinfo/Europe/Berlin /etc/localtime
hwclock --systohc

# vim /etc/locale.gen
sed -i 's/#\(de_DE.UTF-8\)/\1/' /etc/locale.gen
locale-gen

echo "LANG=de_DE.UTF-8" >> /etc/locale.conf
echo "KEYMAP=de-latin1" >> /etc/vconsole.conf #only for console not for DE or terminal
echo "FONT=Tamsyn10x20r" >> /etc/vconsole.conf
echo "arch" >> /etc/hostname
# vim /etc/hosts
echo "127.0.0.1	localhost" >> /etc/hosts
echo "::1	localhost" >> /etc/hosts
echo "127.0.1.1	arch.localedomain	arch" >> /etc/hosts
echo root:test | chpasswd

#git clone https://aur.archlinux.org/paru-bin
#cd paru-bin
#makepkg -si
#cd /

#AUR
pacman -S base-devel linux-headers linux-lts-headers

#paru -S zramd

# bind = dnsutils (dig, etc.)
pacman -S dialog reflector xdg-user-dirs xdg-utils inetutils bind bash-completion openssh rsync iptables-nft ipset firewalld lynx

pacman -S efibootmgr mtools dosfstools
#pacman -S grub os-prober efibootmgr mtools dosfstools sof-firmware os-prober

pacman -S iwd plasma plasma-wayland-session kde-applications sddm bluez bluez-utils cups hplip alsa-utils pipewire pipewire-docs pipewire-alsa pipewire-pulse pipewire-jack helvum pavucontrol packagekit-qt5

#Power
pacman -S acpi acpi_call tlp

# Video AMD
pacman -S --noconfirm xf86-video-amdgpu

# System
systemctl enable systemd-networkd
systemctl enable systemd-resolved
systemctl enable sshd
systemctl enable reflector.timer
systemctl enable firewalld
systemctl enable fstrim.timer
# Laptop
systemctl enable iwd
systemctl enable sddm
systemctl enable cups
systemctl enable bluetooth

sed -i 's/MODULES=()/MODULES=(btrfs amdgpu)/' /etc/mkinitcpio.conf

mkinitcpio -p linux
mkinitcpio -p linux-lts

bootctl install

# Bootloaderconfig
echo "timeout 5" > /boot/loader/loader.conf
echo "console max" >> /boot/loader/loader.conf
echo "default arch.conf" >> /boot/loader/loader.conf
#sed -i 's/#\(timeout\)\s[0-9]/\1 5/' /boot/loader/loader.conf
#sed -i 's/#\(console\)/\1/' /boot/loader/loader.conf
#sed -i 's/keep/max/' /boot/loader/loader.conf
#sed -i 's/\(default\s\).*/\1arch.conf/' /boot/loader/loader.conf

# Entry Arch
echo "title     Arch Linux" >> /boot/loader/entries/arch.conf
echo "linux     /vmlinuz-linux" >> /boot/loader/entries/arch.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch.conf
echo "initrd    /initramfs-linux.img" >> /boot/loader/entries/arch.conf
echo "options   root=LABEL=arch rootflags=subvol=@ rw" >> /boot/loader/entries/arch.conf
# Entry Arch LTS
echo "title     Arch Linux LTS" >> /boot/loader/entries/arch-lts.conf
echo "linux     /vmlinuz-linux-lts" >> /boot/loader/entries/arch-lts.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch-lts.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch-lts.conf
echo "initrd    /initramfs-linux-lts.img" >> /boot/loader/entries/arch-lts.conf
echo "options   root=LABEL=arch rootflags=subvol=@ rw" >> /boot/loader/entries/arch-lts.conf
# Entry Arch Fallback
echo "title     Arch Linux Fallback" > /boot/loader/entries/arch-fallback.conf
echo "linux     /vmlinuz-linux" >> /boot/loader/entries/arch-fallback.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch-fallback.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch-fallback.conf
echo "initrd    /initramfs-linux-fallback.img" >> /boot/loader/entries/arch-fallback.conf
echo "options   root=LABEL=arch rootflags=subvol=@" >> /boot/loader/entries/arch-fallback.conf
# Entry Arch LTS Fallback
echo "title     Arch Linux LTS Fallback" > /boot/loader/entries/arch-fallback.conf
echo "linux     /vmlinuz-linux-lts" >> /boot/loader/entries/arch-lts-fallback.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch-lts-fallback.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch-lts-fallback.conf
echo "initrd    /initramfs-linux-lts-fallback.img" >> /boot/loader/entries/arch-lts-fallback.conf
echo "options   root=LABEL=arch rootflags=subvol=@" >> /boot/loader/entries/arch-lts-fallback.conf

# Netzwerk
# Ethernet
echo "[Match]" >> /etc/systemd/network/20-ethernet.network
echo "Name=en*" >> /etc/systemd/network/20-ethernet.network
echo "Name=eth*" >> /etc/systemd/network/20-ethernet.network
echo "" >> /etc/systemd/network/20-ethernet.network
echo "[Network]" >> /etc/systemd/network/20-ethernet.network
echo "DHCP=yes" >> /etc/systemd/network/20-ethernet.network
echo "IPv6PrivacyExtensions=yes" >> /etc/systemd/network/20-ethernet.network
echo "" >> /etc/systemd/network/20-ethernet.network
echo "[DHCPv4]" >> /etc/systemd/network/20-ethernet.network
echo "RouteMetric=100" >> /etc/systemd/network/20-ethernet.network
echo "" >> /etc/systemd/network/20-ethernet.network
echo "[IPv6AcceptRA]" >> /etc/systemd/network/20-ethernet.network
echo "RouteMetric=100" >> /etc/systemd/network/20-ethernet.network
# Wlan
echo "[Match]" >> /etc/systemd/network/20-wlan.network
echo "Name=wl*" >> /etc/systemd/network/20-wlan.network
echo "" >> /etc/systemd/network/20-wlan.network
echo "[Network]" >> /etc/systemd/network/20-wlan.network
echo "DHCP=yes" >> /etc/systemd/network/20-wlan.network
echo "IPv6PrivacyExtensions=yes" >> /etc/systemd/network/20-wlan.network
echo "" >> /etc/systemd/network/20-wlan.network
echo "[DHCPv4]" >> /etc/systemd/network/20-wlan.network
echo "RouteMetric=600" >> /etc/systemd/network/20-wlan.network
echo "" >> /etc/systemd/network/20-wlan.network
echo "[IPv6AcceptRA]" >> /etc/systemd/network/20-wlan.network
echo "RouteMetric=600" >> /etc/systemd/network/20-wlan.network
# Wwan (Mobilefunk)
echo "[Match]" >> /etc/systemd/network/20-wwan.network
echo "Name=ww*" >> /etc/systemd/network/20-wwan.network
echo "" >> /etc/systemd/network/20-wwan.network
echo "[Network]" >> /etc/systemd/network/20-wwan.network
echo "DHCP=yes" >> /etc/systemd/network/20-wwan.network
echo "IPv6PrivacyExtensions=yes" >> /etc/systemd/network/20-wwan.network
echo "" >> /etc/systemd/network/20-wwan.network
echo "[DHCPv4]" >> /etc/systemd/network/20-wwan.network
echo "RouteMetric=700" >> /etc/systemd/network/20-wwan.network
echo "" >> /etc/systemd/network/20-wwan.network
echo "[IPv6AcceptRA]" >> /etc/systemd/network/20-wwan.network
echo "RouteMetric=700" >> /etc/systemd/network/20-wwan.network

useradd -mG wheel eichehome
echo eichehome:testen | chpasswd

echo "%wheel ALL=(ALL) ALL" >> /etc/sudoers.d/wheel_group

sed -i 's/#\(Color\)/\1/' /etc/pacman.conf
# Umbruch notwendug
sed -i 's/#\(ParallelDownloads\s=\s5\)/\1\
ILoveCandy/' /etc/pacman.conf