# Vor Reboot
ln -sf /usr/share/zoneinfo/Europe/Berlin /etc/localtime
hwclock --systohc

# vim /etc/locale.gen
sed -i 's/#\(de_DE.UTF-8\)/\1/' /etc/locale.gen
locale-gen

echo "LANG=de_DE.UTF-8" >> /etc/locale.conf
echo "KEYMAP=de-latin1" >> /etc/vconsole.conf #only for console not for DE or terminal
echo "FONT=Tamsyn10x20r" >> /etc/vconsole.conf
echo "arch" >> /etc/hostname
# vim /etc/hosts
echo "127.0.0.1	localhost" >> /etc/hosts
echo "::1	localhost" >> /etc/hosts
echo "127.0.1.1	arch.localedomain	arch" >> /etc/hosts
echo root:test | chpasswd

pacman -S base-devel linux-headers linux-lts-headers

pacman -S iwd dialog reflector xdg-user-dirs xdg-utils inetutils ldns bash-completion openssh rsync iptables-nft ipset firewalld lynx

pacman -S efibootmgr mtools dosfstools

pacman -S --noconfirm xf86-video-amdgpu
# pacman -S --noconfirm nvidia nvidia-utils nvidia-settings

systemctl enable systemd-networkd
systemctl enable systemd-resolved
systemctl enable systemd-timesyncd
systemctl enable sshd
systemctl enable reflector.timer
systemctl enable firewalld
systemctl enable fstrim.timer
systemctl enable iwd

sed -i 's/MODULES=()/MODULES=(amdgpu)/' /etc/mkinitcpio.conf #AMD
# sed -i 's/MODULES=()/MODULES=(nvidia)/' /etc/mkinitcpio.conf #Nvidia
# sed -i 's/MODULES=()/MODULES=(i915)/' /etc/mkinitcpio.conf #Intel

mkinitcpio -p linux
mkinitcpio -p linux-lts

bootctl install

# Bootloaderconfig
echo "timeout 5" > /boot/loader/loader.conf
echo "console max" >> /boot/loader/loader.conf
echo "default arch.conf" >> /boot/loader/loader.conf

# Entry Arch
echo "title     Arch Linux" >> /boot/loader/entries/arch.conf
echo "linux     /vmlinuz-linux" >> /boot/loader/entries/arch.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch.conf
echo "initrd    /initramfs-linux.img" >> /boot/loader/entries/arch.conf
echo "options   root=LABEL=arch rootflags=subvol=@ rw" >> /boot/loader/entries/arch.conf
# Entry Arch LTS
echo "title     Arch Linux LTS" >> /boot/loader/entries/arch-lts.conf
echo "linux     /vmlinuz-linux-lts" >> /boot/loader/entries/arch-lts.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch-lts.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch-lts.conf
echo "initrd    /initramfs-linux-lts.img" >> /boot/loader/entries/arch-lts.conf
echo "options   root=LABEL=arch rootflags=subvol=@ rw" >> /boot/loader/entries/arch-lts.conf
# Entry Arch Fallback
echo "title     Arch Linux Fallback" > /boot/loader/entries/arch-fallback.conf
echo "linux     /vmlinuz-linux" >> /boot/loader/entries/arch-fallback.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch-fallback.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch-fallback.conf
echo "initrd    /initramfs-linux-fallback.img" >> /boot/loader/entries/arch-fallback.conf
echo "options   root=LABEL=arch rootflags=subvol=@" >> /boot/loader/entries/arch-fallback.conf
# Entry Arch LTS Fallback
echo "title     Arch Linux LTS Fallback" > /boot/loader/entries/arch-fallback.conf
echo "linux     /vmlinuz-linux-lts" >> /boot/loader/entries/arch-lts-fallback.conf
# AMD
echo "initrd    /amd-ucode.img" >> /boot/loader/entries/arch-lts-fallback.conf
# Intel
# echo "initrd    /intel-ucode.img" >> /boot/loader/entries/arch-lts-fallback.conf
echo "initrd    /initramfs-linux-lts-fallback.img" >> /boot/loader/entries/arch-lts-fallback.conf
echo "options   root=LABEL=arch rootflags=subvol=@" >> /boot/loader/entries/arch-lts-fallback.conf

# Netzwerk
# Ethernet
echo "[Match]" >> /etc/systemd/network/20-ethernet.network
echo "Name=en*" >> /etc/systemd/network/20-ethernet.network
echo "Name=eth*" >> /etc/systemd/network/20-ethernet.network
echo "" >> /etc/systemd/network/20-ethernet.network
echo "[Network]" >> /etc/systemd/network/20-ethernet.network
echo "DHCP=yes" >> /etc/systemd/network/20-ethernet.network
echo "IPv6PrivacyExtensions=yes" >> /etc/systemd/network/20-ethernet.network
echo "" >> /etc/systemd/network/20-ethernet.network
echo "[DHCPv4]" >> /etc/systemd/network/20-ethernet.network
echo "RouteMetric=100" >> /etc/systemd/network/20-ethernet.network
echo "" >> /etc/systemd/network/20-ethernet.network
echo "[IPv6AcceptRA]" >> /etc/systemd/network/20-ethernet.network
echo "RouteMetric=100" >> /etc/systemd/network/20-ethernet.network
# Wlan
echo "[Match]" >> /etc/systemd/network/20-wlan.network
echo "Name=wl*" >> /etc/systemd/network/20-wlan.network
echo "" >> /etc/systemd/network/20-wlan.network
echo "[Network]" >> /etc/systemd/network/20-wlan.network
echo "DHCP=yes" >> /etc/systemd/network/20-wlan.network
echo "IPv6PrivacyExtensions=yes" >> /etc/systemd/network/20-wlan.network
echo "" >> /etc/systemd/network/20-wlan.network
echo "[DHCPv4]" >> /etc/systemd/network/20-wlan.network
echo "RouteMetric=600" >> /etc/systemd/network/20-wlan.network
echo "" >> /etc/systemd/network/20-wlan.network
echo "[IPv6AcceptRA]" >> /etc/systemd/network/20-wlan.network
echo "RouteMetric=600" >> /etc/systemd/network/20-wlan.network
# Wwan (Mobilefunk)
echo "[Match]" >> /etc/systemd/network/20-wwan.network
echo "Name=ww*" >> /etc/systemd/network/20-wwan.network
echo "" >> /etc/systemd/network/20-wwan.network
echo "[Network]" >> /etc/systemd/network/20-wwan.network
echo "DHCP=yes" >> /etc/systemd/network/20-wwan.network
echo "IPv6PrivacyExtensions=yes" >> /etc/systemd/network/20-wwan.network
echo "" >> /etc/systemd/network/20-wwan.network
echo "[DHCPv4]" >> /etc/systemd/network/20-wwan.network
echo "RouteMetric=700" >> /etc/systemd/network/20-wwan.network
echo "" >> /etc/systemd/network/20-wwan.network
echo "[IPv6AcceptRA]" >> /etc/systemd/network/20-wwan.network
echo "RouteMetric=700" >> /etc/systemd/network/20-wwan.network

useradd -mG wheel eichehome
echo eichehome:testen | chpasswd

echo "%wheel ALL=(ALL) ALL" >> /etc/sudoers.d/wheel_group

sed -i 's/#\(Color\)/\1/' /etc/pacman.conf
# Umbruch notwendug
sed -i 's/#\(ParallelDownloads\s=\s5\)/\1\
ILoveCandy/' /etc/pacman.conf

#git clone https://aur.archlinux.org/paru-bin
#cd paru-bin
#makepkg -si
#cd ..

touch /etc/profile.d/sway.sh
echo "export WLR_NO_HARDWARE_CURSORS=1" >> /etc/profile.d/sway.sh
echo 'if [ "$XDG_SESSION_TYPE" == "wayland" ]; then' >> /etc/profile.d/sway.sh
echo "  export MOZ_ENABLE_WAYLAND=1" >> /etc/profile.d/sway.sh
echo '  export QT_QPA_PLATFORM="wayland;xcb"' >> /etc/profile.d/sway.sh
echo "fi" >> /etc/profile.d/sway.sh